#define AVRGCC_VERSION 330
#if AVRGCC_VERSION == 330
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#else
#include <io.h>
#include <pgmspace.h>
#include <eeprom.h>
#endif

#include "lcd_io.h"
#include "strg_form.h"
#include "dcf.h"

int DCF_min;
int DCF;			// 0/1 von DCF gelesen
int DCF_1max;       // maximale 1-Impulslnge
int DCF_0max;
int DCF_last;		// Zhler, lnge des Pegelwechsels
int DCF_cnt;
int DCF_last_input;			// Pegel der bei der letzten Messung am DCF-Eingang gemessen wurde
    // Struktur DCF_ntime: Stunden, Minuten, Sekunden, ??
int DCF_time[4] = {0x00,0x00,0x00,0x00};  // Arry fr aktuelle Zeit
int DCF_ntime[4] = {0x00,0x00,0x00,0x00};   // Array fr nchste Zeit

//#if DCF_Test == 1
	int DCF_test[7] = {0x01,0x01,0x01,0x01,0x01,0x01,0x01};
//#endif
//DCF77_Anzeige();
// DCF - Anzeige der Zeit
//---------------------------------------------------------------------------
int Anzeige(void)
{
	//unsigned int t1;
	//t1 = (IRQ0Cnt -1) /2;
	//dcf77_calc();					// Berechnen der DCF77-Werte
//#if DCF77 == 1
	if ((Menu1 !=1) && (Uhrzeit)) {DCF_Anzeige();};
//	DCF_Anzeige();
//#endif
#if DCF_Test == 1
	if ((Menu1 !=1) && (Z_Status)) {DCF_Test_Anzeige();};
#endif

/*
   // Bar-Zeichen anzeigen
   lcd_gotoxy(11,3);
   lcd_putc(BarCnt);
   BarCnt ++;
	if (BarCnt == 5) {BarCnt = 0;};
*/
	return (0);
};

/*######################################################################################################*/
// Prob: Sekunden knnen ber 59 kommen, wenn nicht ein Minutenendeimpuls empfangen wurde
void dcf77_calc1(void)
{
//#if DCF77 == 1
	// unsigned
	int a;
	a = dcf77_set();
	DCF = a;
	DCF_last ++;     			// Zhler wird bei jedem Pegelwechsel auf 0 gesetzt
	if (DCF_last_input != a)	// Flankenwechsel am DCF-Pin
	{
        if (a == 0)
        {
            if (DCF_last < (DCF_0max -30))		// 0 von DCF eingelesen
            {
            	DCF_min = DCF_last;
            	DCF = 0;
            };
            if (DCF_cnt == 19)					// Zeit auf 0 setzen
            {	DCF_ntime[0] = 0;	DCF_ntime[1] = 0; };
			// Minuten/Stunden im Array berechnen
        	if (DCF_last > (DCF_0max -10)) 		// 1 von DCF eingelesen
        	{
        		DCF_0max = DCF_last;
        		DCF = 1;
                switch (DCF_cnt)
                {
                    case DCF_MIN1: 	DCF_ntime[1] = DCF;break;
                    case DCF_MIN2: 	DCF_ntime[1] = DCF_ntime[1] +2; break;
                    case DCF_MIN4: 	DCF_ntime[1] = DCF_ntime[1] +4; break;
                    case DCF_MIN8: 	DCF_ntime[1] = DCF_ntime[1] +8; break;
                    case DCF_MIN10: DCF_ntime[1] = DCF_ntime[1] +10; break;
                    case DCF_MIN20: DCF_ntime[1] = DCF_ntime[1] +20; break;
                    case DCF_MIN40: DCF_ntime[1] = DCF_ntime[1] +40; break;
                };
                switch (DCF_cnt)
                {
                   	case DCF_STD1: 	DCF_ntime[0] = DCF; break;
                    case DCF_STD2: 	DCF_ntime[0] = DCF_ntime[0] +2; break;
                    case DCF_STD4: 	DCF_ntime[0] = DCF_ntime[0] +4; break;
                    case DCF_STD8: 	DCF_ntime[0] = DCF_ntime[0] +8; break;
                    case DCF_STD10: DCF_ntime[0] = DCF_ntime[0] +10; break;
                    case DCF_STD20: DCF_ntime[0] = DCF_ntime[0] +20; break;
                };
        	};

//			if ((DCF_cnt+5) > DCF_last)
//			{
//				DCF_cnt = DCF_last;
//			};
            // Sekunden in den Zeitarrays abspeichern
            DCF_ntime[2] = DCF_cnt;
			DCF_time[2]  = DCF_cnt;
	#if DCF_Test == 1
            // -------------------- Test, Minuten in einem Array ablegen ------
            switch (DCF_cnt)
            {
                case DCF_MIN1: DCF_test[6] = DCF; break;
                case DCF_MIN2: DCF_test[5] = DCF; break;
                case DCF_MIN4: DCF_test[4] = DCF; break;
                case DCF_MIN8: DCF_test[3] = DCF; break;
                case DCF_MIN10: DCF_test[2] = DCF; break;
                case DCF_MIN20: DCF_test[1] = DCF; break;
                case DCF_MIN40: DCF_test[0] = DCF; break;
            };

	#endif
//#endif
            Anzeige();
            //DCF_Anzeige();
//#if DCF77 == 1
            DCF_cnt ++;
        };
        if (a == 1)
        {
        	if (DCF_last > (DCF_1max -20))
        	{
        		DCF_1max = DCF_last;
				DCF_cnt = -1;
				DCF_time[0] = DCF_ntime[0];
				DCF_time[1] = DCF_ntime[1];
				//DCF_time[2] = DCF_ntime[2]; 		// wird nicht bentigt
        	};
        };
        DCF_last_input = a;
		DCF_last = 0;
	};
	// Wenn kein DCF-Impuls anliegt wird 99:99:xx angezeigt
	if (DCF_last > 1000)
	{
        DCF_1max = 20;
        DCF_0max = 20;
        DCF_min = 10;
		DCF_time[1] = 99;
		DCF_time[0] = 99;
        Anzeige();
        DCF_cnt = -1;
        DCF_last = 800;
	};
//#endif
};
/*######################################################################################################*/
//-------------------------------------------------------------------------
//#if DCF_Test == 1 && DCF77 == 1
extern void	DCF_Test_Anzeige(void)
{
// DCF - Anzeige der nchsten Minute
	lcd_gotoxy (10,0);
	left_0(DCF_ntime[0]);					// Stunden
	lcd_puts_P(":");
	left_0(DCF_ntime[1]);				// Minuten
	lcd_puts_P(":");
	left_0(DCF_ntime[2]);				// Sekunden
	lcd_puts_P("   ");

	lcd_gotoxy(0,2);
	left_0(DCF_cnt);		//Impulszhler
	lcd_puts_P(" ");
	lcd_puti(DCF_min,0);		//Krzester 0-Impuls
	lcd_puts_P(" ");
	lcd_puti(DCF_0max,0);		//Lngster 0-Impuls
	lcd_puts_P(" ");
	lcd_puti(DCF_1max,0);		//Lngster 1-Impuls
	lcd_puts_P(" ");
	left_0(DCF_last);		//Lnge des letzten Impulses
	lcd_puts_P(" ");
//	lcd_puti(DCF_last,0);			//aktueller DCF-Counter
//	lcd_puts_P(" ");
	lcd_puti(DCF,0);			//L oder H empfangen
	lcd_puts_P("      ");
#if DCF_Test == 1
	lcd_gotoxy(12,3);
	lcd_puti(DCF_test[0],0);
	lcd_puti(DCF_test[1],0);
	lcd_puti(DCF_test[2],0);
	lcd_puti(DCF_test[3],0);
	lcd_puti(DCF_test[4],0);
	lcd_puti(DCF_test[5],0);
	lcd_puti(DCF_test[6],0);
#endif
};
//#endif

extern void DCF_Anzeige (void)
{
	if (Z_Status) {lcd_gotoxy (0,3);} else {lcd_gotoxy (12,3);};
	left_0(DCF_time[0]);				// Stunden
	lcd_puts_P(":");
	left_0(DCF_time[1]);				// Minuten
	lcd_puts_P(":");
	left_0(DCF_time[2]);				// Sekunden
	lcd_puts_P("    ");
//#endif
// Ende DCF - Anzeige
};
/*######################################################################################################*/

//--------------------------------------------------------------------------
void dcf77_ini (void)
{
	cbi (DCF_DDR, DCF_BIT);
	DCF_1max = 21;			// und sonstiger Variablen
	DCF_0max = 20;
	DCF_min = 80;
	DCF_last_input = 1;
};
//-------------------------- Liefert 1 wenn DCF = 1 ------------------------
int dcf77_set (void)
{
	int w = 0;
	if (bit_is_set(DCF_PIN, DCF_BIT))
	{ 	w = 1; };
	return(w);
};


// ---------------- Inc Counter wenn dcf gesetzt ist -----------------------
int dcf77_cnt (int w)
{
	if (bit_is_set(DCF_PIN, DCF_BIT))
	{ w++; };
	return(w);
};


















