#ifndef _DCF_H___
#define _DCF_H___

#if AVRGCC_VERSION == 330

	#include <avr/io.h>
	#include <avr/pgmspace.h>
	#include <avr/eeprom.h>

#else

	#include <io.h>
	#include <pgmspace.h>
	#include <eeprom.h>

#endif

#include "test.h"
//-------------------- SW - Switches ------------------------------------
#define DCF_Test   1
// ---------- DCF77 -----------------------------------------------------
//#if DCF77 == 1
    // Versatz von 1 ist erforderlich, da das Bit erst ausgewertet wird,
    // sofern das nchste gestartet wurde (veraltet, vermutlich ka031114)
    #define Versatz 0

    #define DCF_BIT_20 20-Versatz

    #define DCF_MIN1 20+Versatz
    #define DCF_MIN2 21+Versatz
    #define DCF_MIN4 22+Versatz
    #define DCF_MIN8 23+Versatz
    #define DCF_MIN10 24+Versatz
    #define DCF_MIN20 25+Versatz
    #define DCF_MIN40 26+Versatz

    #define DCF_STD1 28+Versatz
    #define DCF_STD2 29+Versatz
    #define DCF_STD4 30+Versatz
    #define DCF_STD8 31+Versatz
    #define DCF_STD10 32+Versatz
    #define DCF_STD20 33+Versatz
//#endif

//#include "lcd_io.h"

// ----------------- Variablen anlegen --------------------------------
extern	int DCF_min;
extern	int DCF;			// 0/1 von DCF gelesen
//extern
extern int DCF_1max;       // maximale 1-Impulslnge
//extern
extern int DCF_0max;
extern	int DCF_last;		// Zhler, lnge des Pegelwechsels
extern	int DCF_cnt;
extern	int DCF_last_input;			// Pegel der bei der letzten Messung am DCF-Eingang gemessen wurde

    // Struktur DCF_ntime: Stunden, Minuten, Sekunden, ??
extern int DCF_time[4];		// Arry fr aktuelle Zeit
extern int DCF_ntime[4];	// Array fr nchste Zeit
#if DCF_Test == 1
	extern int DCF_test[7];
#endif
// DCF input Port und PIN, muss manuell angepasst werden,
// wenn ein anderer Port/Pin genutzt wird
#define DCF_BIT 2
#define DCF_DDR DDRD
#define DCF_PIN PIND

int Anzeige(void);
//------------------------------------------------------------------
extern void dcf77_calc1(void);
extern void	DCF_Test_Anzeige(void);
extern void DCF_Anzeige (void);
//------------------------------------------------------------------
extern void dcf77_ini (void);
extern int dcf77_cnt (int w);
extern int dcf77_set (void);

#endif    // _DCF_H___












