/****************************************************************************
 Title  :   Allgemeines Testprg
 Author:    Volker Kattoll
 Date:      22/11/2003
 Software:  AVR-GCC with AVR-AS
 Target:    AVR Mega32
 Comments:

*****************************************************************************/
#include "test.h"


#include "lcd_io.h"
//wird bentigt !! Ohne werden keine Interrupts verarbeitet ka031026
#include <avr/interrupt.h>
#include <avr/signal.h>

//---------------- Software-Switches -----------------------
//         0 = Aus,  1 = Ein
#define IRQ0        0
// Schalter haben hier keinen Einfluss auf eine Steuerung in den Headerdateien
#define DCF77       1

// ----------------- Menu -----------------------------------
//static const unsigned char bar1[8]__attribute__((progmem)) = {0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01};
static  unsigned char eeprom_menu1[]__attribute__((section(".eeprom")))={" Uhrzeit       "};//," Uhrzeit       Aus  "};
static  unsigned char eeprom_menu2[]__attribute__((section(".eeprom")))={" Zeitstatus    "};
static  unsigned char eeprom_menu3[]__attribute__((section(".eeprom")))={" Tastenstatus  "};
static  unsigned char eeprom_menu4[]__attribute__((section(".eeprom")))={" zurueck     ->INFO "};

static unsigned char m_an[]__attribute__((section(".eeprom")))={"An  "};
static unsigned char m_aus[]__attribute__((section(".eeprom")))={"Aus  "};

//--------------- Module -----------------------------------
#include "delay.h"

#include "dcf.h"

#include "irq.h"

#include "strg_form.h"

//----------------------------------------------------------

// ---------- Eigene Variablen die im Prg genutzt werden ----------------
#define PrgVers "0.2o"
#define PrgDate "06.12.03"
static  unsigned char prog_vers1[]__attribute__((section(".eeprom")))={" Program - Version  "};
static  unsigned char prog_vers2[]__attribute__((section(".eeprom")))={"Vers: "PrgVers" "PrgDate};

// Anlegen Hauptmenu-Strings
static  unsigned char m1s1[]__attribute__((section(".eeprom")))={"Menu1 Punkt1"};
static  unsigned char m1s2[]__attribute__((section(".eeprom")))={"Menu1 Punkt2"};
static  unsigned char m1s3[]__attribute__((section(".eeprom")))={"Menu1 Punkt3"};
static  unsigned char m1s4[]__attribute__((section(".eeprom")))={"Menu1 Punkt4"};
static  unsigned char m1s5[]__attribute__((section(".eeprom")))={"Menu1 Punkt5"};
static  unsigned char m1s6[]__attribute__((section(".eeprom")))={"Menu1 Punkt6"};

// Pointer-Array auf Hauptmenu-Strings
static const unsigned char* m1[6]__attribute__((progmem)) = {m1s1,m1s2,m1s3,m1s4,m1s5,m1s6};


// Fr grosse DCF-Anzeige
static  unsigned char z0s1[]__attribute__((section(".eeprom")))={" 00 "};
static  unsigned char z0s2[]__attribute__((section(".eeprom")))={"0  0"};
static  unsigned char z0s3[]__attribute__((section(".eeprom")))={"0  0"};
static  unsigned char z0s4[]__attribute__((section(".eeprom")))={" 00 "};

static  unsigned char z1s1[]__attribute__((section(".eeprom")))={"  00"};
static  unsigned char z1s2[]__attribute__((section(".eeprom")))={" 0 0"};
static  unsigned char z1s3[]__attribute__((section(".eeprom")))={"   0"};
static  unsigned char z1s4[]__attribute__((section(".eeprom")))={"   0"};

static  unsigned char z2s1[]__attribute__((section(".eeprom")))={" 00 "};
static  unsigned char z2s2[]__attribute__((section(".eeprom")))={"0  0"};
static  unsigned char z2s3[]__attribute__((section(".eeprom")))={"  0"};
static  unsigned char z2s4[]__attribute__((section(".eeprom")))={"0000"};

static  unsigned char z3s1[]__attribute__((section(".eeprom")))={" 00 "};
static  unsigned char z3s2[]__attribute__((section(".eeprom")))={"  _0"};
static  unsigned char z3s3[]__attribute__((section(".eeprom")))={"   0"};
static  unsigned char z3s4[]__attribute__((section(".eeprom")))={" 00 "};

//					Pointer auf die Zahlentabellen
static const unsigned char* z0[4]__attribute__((progmem)) = {z0s1,z0s2,z0s3,z0s4};
static const unsigned char* z1[4]__attribute__((progmem)) = {z1s1,z1s2,z1s3,z1s4};
static const unsigned char* z2[4]__attribute__((progmem)) = {z2s1, z2s2, z2s3, z2s4};
static const unsigned char* z3[4]__attribute__((progmem)) = {z3s1,z3s2,z3s3,z3s4};

//unsigned __attribute__((progmem)) char* p1;//         			Pointer auf die Zahlen 0-9
//static unsigned * zahl[10]__attribute__((progmem)) = {z0[0],z1[0],z2,z3,z3,z3,z3,z3,z3,z3};


//static const unsigned char* s[]__attribute__((".eeprom")) = {s1,s2};

// ---------- Globale Variablen ---------------------------
// ----------------- Variablen anlegen --------------------------------
#define Del_Cnt_Start 9
int Del_Cnt = Del_Cnt_Start;
//------------------ Tastatur -----------------------------------------
#define TASTENVERZOEGERUNG  20
/*	Richtige Tastenbelegung
#define T_OBEN    1
#define T_RECHTS  2
#define T_MITTE   4
#define T_UNTEN   8
#define T_LINKS  16
*/
#define T_OBEN    10
#define T_RECHTS  9
#define T_MITTE   12
#define T_UNTEN   24
#define T_LINKS   24

uint8_t Taste;			// gedrckte Taste
uint8_t Taste_letzte;	// vorletzte Taste
// Tastencounter:  wird bei jedem Durchlauf decrementiert, wenn 0,
// dann ist die Taste gltig
uint8_t Taste_Cnt;
uint8_t t1;				// Verzgerung in den Menues


	//unsigned
	int Cnt1;
	//unsigned
	int BarCnt;
#if IRQ0 == 1
    //unsigned
    int IRQ0Cnt;
#endif
//	int Cnt;
//	int temp;

	//unsigned char DCF_ntime[4]__attribute__((progmem)) = {0x00,0x00,0x00,0x00};
//-----------------------------------------------------------------------
  // USER DEFINED CHARS ARRAY's   // nur 8 Chars sind mglich
static const unsigned char bar1[8]__attribute__((progmem)) = {0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01};
static const unsigned char bar2[8]__attribute__((progmem)) = {0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02};
static const unsigned char bar3[8]__attribute__((progmem)) = {0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04};
static const unsigned char bar4[8]__attribute__((progmem)) = {0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08};

static const unsigned char bar5[8]__attribute__((progmem)) = {0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10};

static const unsigned char bar6[8]__attribute__((progmem)) = {0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11};
static const unsigned char bar7[8]__attribute__((progmem)) = {0x12,0x12,0x12,0x12,0x12,0x12,0x12,0x12};
static const unsigned char bar8[8]__attribute__((progmem)) = {0x14,0x14,0x14,0x14,0x14,0x14,0x14,0x14};

/*
You could also define a char array like this:
static const unsigned char user_chars[2][8]__attribute__((progmem))={
                                                                      {0x0E,0x11,0x0E,0x04,0x1F,0x04,0x0A,0x11},
                                                                      {0x11,0x0A,0x04,0x1F,0x04,0x0E,0x11,0x0E}
                                                                    };
or

static const unsigned char user_chars[]__attribute__((progmem))={
                                                                  0x0E,0x11,0x0E,0x04,0x1F,0x04,0x0A,0x11,
                                                                  0x11,0x0A,0x04,0x1F,0x04,0x0E,0x11,0x0E
                                                                };

    and use the macro "lcd_fill_cgram(user_chars);"  instead of uploading each char separately.
    The array can have from 1 up to 8 used defined chars (max 64 bytes) but the macro will upload only
    as much as the array size so in the above example it will fill user defined char positions 0 and 1
    and will not overwrite user defined chars that might exist located at position 2 to 7.
    However it will always start uploading at position 0.

*/
/*######################################################################################################*/
/*######################################################################################################*/

void show_dcf_big(void)
{
	volatile uint8_t L;
	unsigned char* p1;

	//unsigned char* p2;
	//unsigned char* p3;
	//unsigned char* p4;
	unsigned int L1;
	volatile uint8_t versatz;
	versatz = 0;

            
            
			for (L1 = 0; L1 < 5; L1 ++)
			{
	            // Diese Zeile liefert einen Pointer ber z2[1] auf den String z2s2 zurck
	            p1 = (unsigned char*) z2[1];
				
				// Wenn L1 = 1, so sollte diese Zeile ein identisches Ergebnis liefern
				// das macht sie aber nicht.
				// Warum?
            
	            //p1 = (unsigned char*)(z2[(unsigned int)L1]);
	            
				lcd_gotoxy (0,L1);
				lcd_puts_e(p1);
	            
		    };
};

/*######################################################################################################*/
/*######################################################################################################*/
//------------------ Initialisierung von IRQ0 ----------------------
#if IRQ0 == 1
void int_irq0_init(void)
{
	// Interruptsense auf ANY LOCIGAL CHANGE
	// und aktiviert den Interrupt
	outp(BV(ISC00), MCUCR);		// setzt ISC00 = 1, ISC01 ist vom Reset 0
	outp(BV(INT0), GICR);		// INT0 aktivieren
};
// --------------- Verarbeitung von IRQ0 ----------------------------
SIGNAL(SIG_INTERRUPT0)
{
	//unsigned
	cli();								// interrupts sperren
    	IRQ0Cnt ++;						// Tue irgendwas
    sei();                              //Interrupt wieder erlauben
	if (IRQ0Cnt > 10)
	{    	Anzeige();};
};
#endif    //IRQ0 == 1

// --------- Initialisiert den Timerinterrupt ----------------------
void int_timer_init(void)
{
	// Initialisierung Timer2 (16 Bit)
	// Versuch den Timerinterrupt ber Vorteiler zu steuern
	// z.Zt. steuert Timer1 (16-Bit) die Anzeige
    //	outp(BV(CS10), TCCR1B);             //tmr1 running with full MCU clock
    //	outp(BV(CS11), TCCR1B);             //tmr1 running with MCU/8 clock CS11 muss 0 sein
    //	outp(BV(CS12), TCCR1B);             //tmr1 running with MCU/256 clock CS11 muss 0 sein

    //8-Bit-Timer (Timer0) steuer
    //die DCF-H/L-Zhlung
    //aktualisiert wenn der Start einer neue Sekunde empfangen wurde die Anzeige

    //Prob:
    //Wird kein Signal empfangen, wird (glaube ich!) die Anzeige nicht aktualisiert

	// z.Zt. steuert Timer0 (8-Bit) die DCF-High-Low-zhlung
	// durch Timerberlaeufe die gezhlt werden und die Anzeige wird jede Sekunde aktualisiert
	//outp(BV(CS00), TCCR0);				//tmr0 running with full clock CS00 muss 0 sein
	outp(BV(CS01), TCCR0);				//tmr0 running with MCU/8 clock CS01 muss 0 sein
	//outp(BV(CS02), TCCR0);				//tmr0 running with clock/64 CS00 muss 0 sein
//	timer_enable_int (BV(TOIE1)|BV(TOIE0));	//16 und 8-Bit-Timerinterrupt enable
//	timer_enable_int (BV(TOIE1));			//16-Bit-Timerinterrupt enable
	timer_enable_int (BV(TOIE0));			// 8-Bit-Timerinterrupt enable
//    l2 = 0;
};
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void menu2 (uint8_t ta)
{
	uint8_t L;
			lcd_clrscr();
			lcd_gotoxy (0,0);
			lcd_puts_e(prog_vers1);
//			lcd_puts_e(s[1]);
			lcd_gotoxy (0,1);
			lcd_puts_e(prog_vers2);
			lcd_puts_P ("      ");
			// Bar ausgeben
			lcd_gotoxy (0,2);
			for (L = 0; L < Bar1_Wert; L ++)
			{
				lcd_puts_P ("-");
			};
			lcd_gotoxy (0,3);
			lcd_puts_P ("Mitte  -->   zurueck");

			if (ta == T_LINKS) {Bar1_Wert --;};
			if (ta == T_RECHTS) {Bar1_Wert ++;};

			if (ta == T_MITTE) {Menu2 = 0;};
};
//---------------------------------------------------------------------------
void menu1 (uint8_t ta)
{
	t1++;
	if (t1 > 10)
	{
		/*
		for (L = 0; L < 3; L++)
		{
			lcd_gotoxy (0,L);
            lcd_puts_e(eeprom_menu1);
            if (Uhrzeit == AN) { lcd_puts_e(m_an);} else { lcd_puts_e (m_aus);};
		};
		*/
		if (Menu2 == 1)		// ruft Menu2 auf
		{
			menu2(ta);
			return;
		};


        lcd_gotoxy (0,0);
        lcd_puts_e(eeprom_menu1);
        if (Uhrzeit == AN) { lcd_puts_e(m_an);} else { lcd_puts_e (m_aus);};
        lcd_gotoxy (0,1);
        lcd_puts_e(eeprom_menu2);
        if (Z_Status == AN) { lcd_puts_e(m_an);} else { lcd_puts_e (m_aus);};
        lcd_gotoxy (0,2);
        lcd_puts_e(eeprom_menu3);
        if (T_Status == AN) { lcd_puts_e(m_an);} else { lcd_puts_e (m_aus);};
        lcd_gotoxy (0,3);
        lcd_puts_e(eeprom_menu4);
        if (ta == T_OBEN) {Menu1Pos --;};           // Curso-Position berechnen
        if (ta == T_UNTEN) {Menu1Pos ++;};
        if (Menu1Pos > 4) {Menu1Pos = 1;};
        if (Menu1Pos < 1) {Menu1Pos = 4;};
        lcd_gotoxy (0,(Menu1Pos -1));
        lcd_puts_P(">");
        if ((Menu1Pos == 1) && (ta == T_MITTE))
        {
        	if (Uhrzeit == AN) {Uhrzeit = AUS;} else {Uhrzeit = AN;};
        };
        if ((Menu1Pos == 2) && (ta == T_MITTE))
        {
        	if (Z_Status ==  AN) {Z_Status =  AUS;} else {Z_Status =  AN;};
        };
        if ((Menu1Pos == 3) && (ta == T_MITTE))
        {
        	if (T_Status ==  AN) {T_Status = AUS;} else {T_Status = AN;};
        };


		if ((Menu1Pos == 4) && (ta == T_RECHTS))
		{
			Menu2 = 1;
		};

        if ((Menu1Pos == 4) && (ta == T_MITTE))

        {
 			//Menu1Pos = 1;
        	Menu1 = 0;
			lcd_clrscr();
        };

        t1 = 0;
	};
	return;
};
//---------------------------------------------------------------------------
int get_taste(void)
{
	uint8_t a;
	cbi (DDRD, 3);
	cbi (DDRD, 4);
	cbi (DDRD, 5);
	cbi (DDRD, 6);  //Problem: PIN D6 ist manchmal gesetzt, warum ?? (ka031123)
	cbi (DDRD, 7);
	Taste = 0;
	a = inp(PIND);
	Taste = a;
	Taste = Taste >> 3;	//unteren 3 Bit ausblenden
	Taste = Taste -31;  // keine Taste = 0, Taste = -1 bis -16
	Taste = Taste *(-1); // umrechnen in positive Werte
	if ((Menu1 != 1) && (T_Status))
	{
	    lcd_gotoxy(0,2);
	    lcd_puts_P("Taste:");
	    lcd_puti(Taste,0);
	    lcd_puts_P("-");
	    lcd_puti(Taste_letzte,0);
	    lcd_puts_P("-");
	    lcd_puti(Taste_Cnt,0);
	};
//    Del_Cnt --;
		if (Taste > 0)                     // Taste gedrueckt
		{
			if (Taste == Taste_letzte)
			{
				Taste_Cnt --;				// Tastenzaehler runterzaehlen
			};
			if (Taste != Taste_letzte)
			{
				Taste_letzte = Taste;
            	Taste_Cnt = (unsigned int) TASTENVERZOEGERUNG;
			}
		};
		if (Taste == 0)
        {
            Taste_Cnt = (unsigned int) TASTENVERZOEGERUNG;
        };
		// Wenn Tastenverzgerung abgelaufen,
        if (Taste_Cnt == 0)
        {
        	Taste = Taste_letzte;
        	Taste_Cnt = (unsigned int) TASTENVERZOEGERUNG;
        }
        else
        {
            Taste = 0;
        };


	return(Taste);
};
//---------------------------------------------------------------------------
// Bei jedem Timeroverflow die Anzeige neu darstellen
SIGNAL(SIG_OVERFLOW0)
{
	int t;
    t = get_taste();
	if ((Menu1 == 0) && (T_Status))
	{
    	lcd_gotoxy(16,2);
    	lcd_puts_P("T:");
    	lcd_puti(t,0);
    	lcd_puts_P("   ");
    };
    t1 ++;
	if (t1 > 20)
	{
        if ((t == T_MITTE) && (Menu1 == 0))
        {
            Menu1 = 1;
            t1 = 0;
            t = 0;
        };
        if (Menu1 == 1)  {menu1(t);}   //
        t1 = 0;
	};
//    if ((Menu1 == 0) && (Menu2 == 0))
//    {
        //show_dcf_big();
//    };

	dcf77_calc1();
};
//---------------------------------------------------------------------------
int main(void)
{
//	unsigned int BarCnt;
/*
	Wichtig: 	Der EEProm-String muss auch gespeichert sein.
				(EEP in AVR speichern)
*/
Uhrzeit = AN;
T_Status = AUS;
Z_Status = AN;
Bar1_Wert = 4;
Taste_Cnt = TASTENVERZOEGERUNG;   // Anfangswert fr Tastenverzoegerung

unsigned char ram_string[]={"DONE TESTING..."};
static  unsigned char eeprom_string1[]__attribute__((section(".eeprom")))={"String1 aus EEPROM"};

/*11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111*/
#if LCD_SAVE_MORE_CODE_SPACE == 0
/*11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111*/
/* It may seems strange that i use a union but this approach saves a lot of code space */
union double_byte_union {
                           unsigned int  integer;
                           unsigned char byte[2];
                         } word;

/*
    MANUAL LCD INITIALIZATION IS NOT NEEDED ANYMORE. IT IS DONE AUTOMATICALLY!
    lcd(s) is(are) automatically initialized and if more than 1, lcd unit 0 gets active.
    You can always call "lcd_init()" if you wish.
    An exception is when "LCD_ABSOLUTELY_MINIMUM == 1". Then a call to "lcd_init()" is needed.

*/
//lcd_init();

/*
   UPLOAD USER DEFINED CHARS TO LCD's CGRAM AND THEN RETURN TO THE PREVIUS DDRAM CURSOR POSITION
   (It can be made anywhere as long you upload them before you use them)
*/


   lcd_putc_cgram(bar1,0);
   lcd_putc_cgram(bar2,1);
   lcd_putc_cgram(bar3,2);
   lcd_putc_cgram(bar4,3);
   lcd_putc_cgram(bar5,4);
   lcd_putc_cgram(bar6,5);
   lcd_putc_cgram(bar7,6);
   lcd_putc_cgram(bar8,7);
//   lcd_putc_cgram(bar9,8);
   /* DISPLAY USER DEFINED CHARS */

   lcd_gotoxy(0,1);
   lcd_clrscr(); lcd_puts_P( "LCD DCF \nVers: "PrgVers" "PrgDate" ");

/*
// Anzeige der User-Definierten Char
// wird z.Zt. nicht bentigt
   lcd_gotoxy(9,0);
   lcd_putc(0);
   lcd_putc(1);
   lcd_putc(2);
   lcd_putc(3);
   lcd_putc(4);
   lcd_putc(5);
   lcd_putc(6);
   lcd_putc(7);
*/
/*---------------------------------------------------------------------------------------------------*/

#if LCD_AUTO_LINE_FEED == 1
  lcd_puts_e(eeprom_string1); lcd_puts(ram_string);
#elif LCD_AUTO_LINE_FEED == 0
/*---------------------------------------------------------------------------------------------------*/
/*
   I puted this command here to test the correct saving of the lcd x,y coordinates
   between lcd unit switching, if you select mode 7
*/


   lcd_gotoxy(0,2); lcd_puts_P("NOT VISIBLE LINE");
   lcd_clrline(2);  lcd_puts_e(eeprom_string1);
   lcd_gotoxy(0,3); lcd_puts(ram_string);
#endif /* #elif LCD_AUTO_LINE_FEED == 0 */



#if LCD_READ_REQUIRED == 1

/*
   Read a char from the lcd DDRAM at the selected position and then display the read char to another location.
   When using the lcd_getc() function the Address Counter (AC) is auto incremented or decremented
   according to the ENTRY MODE selected during initialization, just like the lcd_putc() function works,
   so when doing a sequential read, there is no need to reposition the cursor each time a read is performed.
   EXAMPLE: To backup line 1 only of the lcd, the below code works fine.

            unsigned char lcd_backup[LCD_CHARS_PER_LINE];
            unsigned char x=0;
            lcd_gotoxy(0,1);
            for(x=0; x<LCD_CHARS_PER_LINE; x++)
              {
                *(lcd_backup+x)=lcd_getc();
              }
*/

//Char-Position auslesen
unsigned char  x=0;
lcd_gotoxy(0,0);
x=lcd_getc();
lcd_gotoxy(19,1); lcd_putc(x);




#endif

/*11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111*/
#elif LCD_SAVE_MORE_CODE_SPACE == 1
/*11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111*/

unsigned char  x=0;

//lcd_init();
lcd_clrscr();

#if   LCD_PUTS_P_NEEDED == 1
lcd_puts_P("Hello World");
#elif LCD_PUTS_P_NEEDED == 0
static  unsigned char progmem_string1[]__attribute__((progmem))={"Hello World"};
for(x=0; x<(sizeof(progmem_string1)-1); x++) { lcd_putc(PRG_RDB(progmem_string1+x)); }
#endif

lcd_gotoxy(0,1);
static  unsigned char progmem_string2[]__attribute__((progmem))={"this is line 2"};
for(x=0; x<(sizeof(progmem_string2)-1); x++) { lcd_putc(PRG_RDB(progmem_string2+x)); }

lcd_gotoxy(0,2);
#if   LCD_PUTS_E_NEEDED == 1
lcd_puts_e(eeprom_string1);
#elif LCD_PUTS_E_NEEDED == 0
for(x=0; x<(sizeof(eeprom_string1)-1); x++) { lcd_putc(eeprom_rb((unsigned int)eeprom_string1+x)); }
#endif

lcd_gotoxy(0,3);
for(x=0; x<(sizeof(ram_string)-1); x++) { lcd_putc(ram_string[x]); }

lcd_goto_cgram(0);
for(x=0; x<8; x++) { lcd_putc(PRG_RDB(user_char1+x)); }
lcd_gotoxy(15,1);
lcd_putc(0);

#if LCD_READ_REQUIRED == 1
lcd_gotoxy(0,0);
x=lcd_getc();
lcd_gotoxy(19,1);
lcd_putc(x);
#endif

#if LCD_PUT_I_NEEDED == 1 && LCD_GETXY_NEEDED == 1
/* It may seems strange that i use a union but this approach saves a lot of code space */
union double_byte_union {
                           unsigned int  integer;
                           unsigned char byte[2];
                         } word;

// Auslesen der LCD-Position
/*
    The return value of the "lcd_getxy()" function is an integer,
    with the high byte containing the current line number (y) and the low byte
    containing the char position in that line (x).
    If the lower byte has a value of 20 that means that you filled that line.
    This position result can only happen when no lcd reading is available.
    When lcd reading is available the maximum x == 19.
*/

lcd_gotoxy(19,3);
word.integer=lcd_getxy();
lcd_gotoxy(16,3);
lcd_puti(*(word.byte+1),0);
lcd_putc(',');
lcd_put_i(*(word.byte),0,2);

#elif LCD_PUT_I_NEEDED == 1 && LCD_GETXY_NEEDED == 0

lcd_gotoxy(16,3);
lcd_puti(319,2);

#endif





/*11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111*/
#endif   /* #if LCD_ABSOLUTELY_MINIMUM == 0 -> #elif LCD_ABSOLUTELY_MINIMUM == 1 */
/*11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111*/

DELAY_MS (1000);

lcd_gotoxy (0,2);
lcd_puts_P ("                    ");

lcd_gotoxy(0,3);
lcd_puts_P(" Test:      ");


for (Cnt1 = 0; Cnt1 < 60; Cnt1 ++)
{
	DCF_time[1] = Cnt1;
	Anzeige();				// Ausgabe auf LCD
    DELAY_MS (20);
};
lcd_clrscr();
for (Cnt1 = 0; Cnt1 < 10; Cnt1 ++)
{
	show_dcf_big();
	DELAY_MS(1000);
};
#if DCF77 == 1
	dcf77_ini();			// Initialisiert DCF-Port
#endif
	// Tastenport als Output definieren
	//cbi (DCF_DDR, 0);
	//cbi (DCF_DDR, 1);
	// Pin 2 = DCF77-Signal




	int_timer_init();
#if IRQ0 == 1
	int_irq0_init();
#endif
	sei();								//Interrupt enable
// Jetzt nur noch Interrupts
	for(;;)			//Endlosschleife die Interrupts erledigen den Rest
        return(0);
}
/*######################################################################################################*/
/*                                         T H E   E N D                                                */
/*######################################################################################################*/